//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  list<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  INSERT_ELEMENTS(coll,1,9);

  PRINT_ELEMENTS(coll," :\n");

  //      4
  list<int>::iterator pos1;
  pos1 = find (coll.begin(), coll.end(),    // 
               4);                          // 

  //      4
  //  -       
  //  -   4 (  )
  list<int>::iterator pos2;
  if (pos1 != coll.end()) {
      pos2 = find (++pos1, coll.end(),      // 
                   4);                      // 
  }

  //        
  //   4,   
  // -  pos1      
  //     4 (  )
  // -       
  //     4 (  )
  cout << ToRus("       \n")
       << ToRus("  4,   :\n");
  if (pos1!=coll.end() && pos2!=coll.end()) {
      copy (--pos1, ++pos2,
            ostream_iterator<int>(cout," "));
      cout << endl;
  }


  getch();
  return 0;
}

//---------------------------------------------------------------------------